package org.jbpm.examples.ejbs;

import java.util.List;
import java.util.Map;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.inject.Inject;

import org.jbpm.examples.util.StartupBean;
import org.jbpm.kie.services.impl.CommonUtils;
import org.jbpm.services.api.RuntimeDataService;
import org.jbpm.services.api.UserTaskService;
import org.jbpm.services.task.commands.CompleteTaskCommand;
import org.jbpm.services.task.commands.CompositeCommand;
import org.jbpm.services.task.commands.StartTaskCommand;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.task.TaskService;
import org.kie.api.task.model.Task;
import org.kie.api.task.model.TaskSummary;
import org.kie.internal.runtime.manager.context.ProcessInstanceIdContext;

@Stateless
@TransactionAttribute(TransactionAttributeType.REQUIRED)
public class TaskEJB {
    @Inject
    private UserTaskService userTaskService;

    @Inject
    TaskService taskService;
	
    @Inject
    private RuntimeDataService runtimeDataService;
    
	public List<TaskSummary> getTasksForUser(String user) {
		return runtimeDataService.getTasksAssignedAsPotentialOwner(user, null);
	}
	
	public Map<String, Object> getTaskContent(Long taskId) {
		return userTaskService.getTaskInputContentByTaskId(taskId);
	}

	public Task getTaskInfo(Long taskId) {
		return userTaskService.getTask(taskId);
	}
	
	public void approveTask(long taskId, String user, Map<String, Object> outputParams) {
		CompositeCommand compositeCommand = new CompositeCommand(new CompleteTaskCommand(taskId, user,
		        outputParams),
		        new StartTaskCommand(taskId, user));
		// TODO: This version is working fine (deployment ID is necessary)
		userTaskService.execute(StartupBean.DEPLOYMENT_ID, compositeCommand);
		
		// TODO: This call is not working correctly, 
		//		 the process is stuck without error after the first user task execution (Jiri) 
		//		 it never reaches Mary's task list (no task is executed after the first user task)
//		taskService.execute(compositeCommand);
	}
}
